searchNodes=[{"ref":"Fuel.html","title":"Fuel","type":"module","doc":"Documentation for Fuel."},{"ref":"Fuel.html#hello/0","title":"Fuel.hello/0","type":"function","doc":"Hello world. Examples iex&gt; Fuel.hello() :world"},{"ref":"Fuel.Ctx.html","title":"Fuel.Ctx","type":"module","doc":"Provides functions for interacting with a ctx. The ctx is based on the golang context.Context and provides many of the same functional features. Using a ctx provides a common thread of data that can be used all through your application. It can be used in plug, grpc, graphql or just within your application to facilitate testing. You can include things like implementation of behaviours Authentication information ids - request, trace etc deadlines arbitrary values @see https://github.com/tsloughter/ctx"},{"ref":"Fuel.Ctx.html#background/0","title":"Fuel.Ctx.background/0","type":"function","doc":"Fetch a new deadline"},{"ref":"Fuel.Ctx.html#ctx_from/1","title":"Fuel.Ctx.ctx_from/1","type":"function","doc":"Fetches a ctx from a kw list or map or returns a new one"},{"ref":"Fuel.Ctx.html#ctx_into/2","title":"Fuel.Ctx.ctx_into/2","type":"function","doc":"puts a ctx into a kwlist or map"},{"ref":"Fuel.Ctx.html#deadline/1","title":"Fuel.Ctx.deadline/1","type":"function","doc":"true if the deadline has not yet exceeded. false"},{"ref":"Fuel.Ctx.html#deadline_exceeded?/1","title":"Fuel.Ctx.deadline_exceeded?/1","type":"function","doc":""},{"ref":"Fuel.Ctx.html#done/1","title":"Fuel.Ctx.done/1","type":"function","doc":"True when the time is earlier than the deadline. False if the deadline has elapsed"},{"ref":"Fuel.Ctx.html#fetch_impl/2","title":"Fuel.Ctx.fetch_impl/2","type":"function","doc":"Fetches an implementation from the given context. If no implementation has been explicitly provided, use the behaviour module as the implementation"},{"ref":"Fuel.Ctx.html#fetch_impl/3","title":"Fuel.Ctx.fetch_impl/3","type":"function","doc":"Fetches the implementation for the given behavioru from the given context. If no implementation has been explicitly provided, fall back to the deafult implementation provided"},{"ref":"Fuel.Ctx.html#get/2","title":"Fuel.Ctx.get/2","type":"function","doc":"Get a value at a key. Missing values will raise a KeyError"},{"ref":"Fuel.Ctx.html#get/3","title":"Fuel.Ctx.get/3","type":"function","doc":"Get a value at a key. Missing values will return the default"},{"ref":"Fuel.Ctx.html#new/0","title":"Fuel.Ctx.new/0","type":"function","doc":"Fetch a new deadline"},{"ref":"Fuel.Ctx.html#set/3","title":"Fuel.Ctx.set/3","type":"function","doc":"Set a value at a key in the context. Any valid term may be used as a key"},{"ref":"Fuel.Ctx.html#with_deadline_after/2","title":"Fuel.Ctx.with_deadline_after/2","type":"function","doc":"Provide a new ctx with a deadline set to elapse after the given time period"},{"ref":"Fuel.Ctx.html#with_deadline_after/3","title":"Fuel.Ctx.with_deadline_after/3","type":"function","doc":"Set a deadline on an existing ctx"},{"ref":"Fuel.Ctx.html#with_impl/3","title":"Fuel.Ctx.with_impl/3","type":"function","doc":"Store the implementation of a behaviour in a context This is useful for changing out behaviours in things like tests where you want to use Mox. @see fetch_impl/2, fetch_impl/3"},{"ref":"Fuel.Ctx.html#with_value/2","title":"Fuel.Ctx.with_value/2","type":"function","doc":"provides a new ctx with the given value"},{"ref":"Fuel.Ctx.html#with_value/3","title":"Fuel.Ctx.with_value/3","type":"function","doc":"Store a value on"},{"ref":"Fuel.Ctx.html#with_values/1","title":"Fuel.Ctx.with_values/1","type":"function","doc":"Provide a new ctx with the given values"},{"ref":"Fuel.Ctx.html#t:behaviour/0","title":"Fuel.Ctx.behaviour/0","type":"type","doc":""},{"ref":"Fuel.Ctx.html#t:impl/0","title":"Fuel.Ctx.impl/0","type":"type","doc":""},{"ref":"Fuel.Ctx.html#t:source/0","title":"Fuel.Ctx.source/0","type":"type","doc":""},{"ref":"Fuel.Ctx.html#t:t/0","title":"Fuel.Ctx.t/0","type":"type","doc":""},{"ref":"readme.html","title":"Fuel","type":"extras","doc":"Fuel Provides some useful modules that help with building consistent applications. Ctx Provides a context object similar to golangs context.Context that provides a way to thread data through a call-stack or even across process boundaries. This is very useful for dependency injection especially when testing. For example setup do ctx = Fuel.Ctx.new() |&gt; Fuel.Ctx.with_impl(MyBehaviour, MyBehaviourMock) {:ok, %{ctx: ctx}} end test &quot;test my thing&quot;, ctx do options = Fuel.Ctx.ctx_into(ctx.ctx, []) MyBehaviourMock |&gt; expect(:some_call, fn _, _ -&gt; :ok end) assert :ok == MyThing.call_a_function(&quot;yay&quot;, options) end In your code: def call_a_function(arg1, options) do with ctx &lt;- Fuel.Ctx.ctx_from(options), my_behaviour &lt;- Fuel.Ctx.fetch_impl(ctx, MyBehaviour) do my_behaviour.some_call(arg1, options) end end Contexts are useful for more than just DI."},{"ref":"readme.html#installation","title":"Fuel - Installation","type":"extras","doc":"If available in Hex, the package can be installed by adding fuel to your list of dependencies in mix.exs: def deps do [ {:fuel, &quot;~&gt; 0.1.0&quot;} ] end Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/fuel."}]